diff -r fb51f5b4aa4c trytond/tests/test_access.py
--- a/trytond/tests/test_access.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/tests/test_access.py	Mon Sep 24 20:36:36 2012 +0200
@@ -374,208 +367,208 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            field1_id, = self.field.search([
-                ('model.model', '=', 'test.access'),
-                ('name', '=', 'field1'),
-                ])
-            field2_id, = self.field.search([
-                ('model.model', '=', 'test.access'),
-                ('name', '=', 'field2'),
-                ])
+            field1, = self.field.search([
+                    ('model.model', '=', 'test.access'),
+                    ('name', '=', 'field1'),
+                    ])
+            field2, = self.field.search([
+                    ('model.model', '=', 'test.access'),
+                    ('name', '=', 'field2'),
+                    ])
 
-            test_id = self.test_access.create({
-                'field1': 'ham',
-                'field2': 'spam',
-                })
+            test = self.test_access.create({
+                    'field1': 'ham',
+                    'field2': 'spam',
+                    })
 
             # Without field access
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
             transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
             # With field access
 
             # One access allowed for any group
-            field_access_wo_group_id = self.field_access.create({
-                'field': field1_id,
-                'group': False,
-                'perm_read': True,
-                })
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
+            field_access_wo_group = self.field_access.create({
+                    'field': field1.id,
+                    'group': False,
+                    'perm_read': True,
+                    })
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
             transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
             # One access disallowed for any group
-            self.field_access.write(field_access_wo_group_id, {
+            self.field_access.write([field_access_wo_group], {
+                    'perm_read': False,
+                    })
+
+            self.assertRaises(Exception, self.test_access.read, [test.id],
+                ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.assertRaises(Exception, self.test_access.read, [test.id])
+            self.assertRaises(Exception, getattr, test, 'field1')
+            test.field2
+            transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
+
+            # Two access rules with one group allowed
+            group = self.group.search([('users', '=', USER)])[0]
+            field_access_w_group = self.field_access.create({
+                    'field': field1.id,
+                    'group': group.id,
+                    'perm_read': True,
+                    })
+
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
+            transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
+
+            # Two access rules with both allowed
+            self.field_access.write([field_access_wo_group], {
+                    'perm_read': True,
+                    })
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
+            transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
+
+            # Two access rules with any group allowed
+            self.field_access.write([field_access_w_group], {
+                    'perm_read': False,
+                    })
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
+            transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
+
+            # Two access rules with both disallowed
+            self.field_access.write([field_access_wo_group], {
                 'perm_read': False,
                 })
+            self.assertRaises(Exception, self.test_access.read, [test.id],
+                ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.assertRaises(Exception, self.test_access.read, [test.id])
+            self.assertRaises(Exception, getattr, test, 'field1')
+            test.field2
+            transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
-            self.failUnlessRaises(Exception, self.test_access.read, test_id,
-                    ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.failUnlessRaises(Exception, self.test_access.read, test_id)
-            test_access = self.test_access.browse(test_id)
-            self.failUnlessRaises(Exception, getattr, test_access, 'field1')
-            test_access.field2
+            # One access disallowed for one group
+            self.field_access.delete([field_access_wo_group])
+            self.assertRaises(Exception, self.test_access.read, [test.id],
+                ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.assertRaises(Exception, self.test_access.read, [test.id])
+            self.assertRaises(Exception, getattr, test, 'field1')
+            test.field2
             transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
-            # Two access rules with one group allowed
-            group_id = self.group.search([('users', '=', USER)])[0]
-            field_access_w_group_id = self.field_access.create({
-                'field': field1_id,
-                'group': group_id,
-                'perm_read': True,
-                })
+            # One access allowed for one group
+            self.field_access.write([field_access_w_group], {
+                    'perm_read': True,
+                    })
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
+            transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
+            # One access allowed for one other group
+            group = self.group.create({'name': 'Test'})
+            self.field_access.write([field_access_w_group], {
+                    'group': group.id,
+                    })
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
             transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
-            # Two access rules with both allowed
-            self.field_access.write(field_access_wo_group_id, {
-                'perm_read': True,
-                })
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
+            # One access disallowed for one other group
+            self.field_access.write([field_access_w_group], {
+                    'perm_read': False,
+                    })
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
             transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
-            # Two access rules with any group allowed
-            self.field_access.write(field_access_w_group_id, {
+            # Two access rules on both fields allowed
+            self.field_access.delete([field_access_w_group])
+
+            field_access1 = self.field_access.create({
+                    'field': field1.id,
+                    'group': False,
+                    'perm_read': True,
+                    })
+            field_access2 = self.field_access.create({
+                    'field': field2.id,
+                    'group': False,
+                    'perm_read': True,
+                    })
+
+            self.test_access.read([test.id], ['field1'])
+            self.test_access.read([test.id], ['field2'])
+            self.test_access.read([test.id])
+            test.field1
+            test.field2
+            transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
+
+            # Two access rules on both fields one allowed and one disallowed
+            self.field_access.write([field_access2], {
                 'perm_read': False,
                 })
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
+            self.test_access.read([test.id], ['field1'])
+            self.assertRaises(Exception, self.test_access.read, [test.id],
+                ['field2'])
+            self.assertRaises(Exception, self.test_access.read, [test.id])
+            test.field1
+            self.assertRaises(Exception, getattr, test, 'field2')
             transaction.cursor.cache.clear()
-
-            # Two access rules with both disallowed
-            self.field_access.write(field_access_wo_group_id, {
-                'perm_read': False,
-                })
-            self.failUnlessRaises(Exception, self.test_access.read, test_id,
-                    ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.failUnlessRaises(Exception, self.test_access.read, test_id)
-            test_access = self.test_access.browse(test_id)
-            self.failUnlessRaises(Exception, getattr, test_access, 'field1')
-            test_access.field2
-            transaction.cursor.cache.clear()
-
-            # One access disallowed for one group
-            self.field_access.delete(field_access_wo_group_id)
-            self.failUnlessRaises(Exception, self.test_access.read, test_id,
-                    ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.failUnlessRaises(Exception, self.test_access.read, test_id)
-            test_access = self.test_access.browse(test_id)
-            self.failUnlessRaises(Exception, getattr, test_access, 'field1')
-            test_access.field2
-            transaction.cursor.cache.clear()
-
-            # One access allowed for one group
-            self.field_access.write(field_access_w_group_id, {
-                'perm_read': True,
-                })
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
-            transaction.cursor.cache.clear()
-
-            # One access allowed for one other group
-            group_id = self.group.create({'name': 'Test'})
-            self.field_access.write(field_access_w_group_id, {
-                'group': group_id,
-                })
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
-            transaction.cursor.cache.clear()
-
-            # One access disallowed for one other group
-            self.field_access.write(field_access_w_group_id, {
-                'perm_read': False,
-                })
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
-            transaction.cursor.cache.clear()
-
-            # Two access rules on both fields allowed
-            self.field_access.delete(field_access_w_group_id)
-
-            field_access1 = self.field_access.create({
-                'field': field1_id,
-                'group': False,
-                'perm_read': True,
-                })
-            field_access2 = self.field_access.create({
-                'field': field2_id,
-                'group': False,
-                'perm_read': True,
-                })
-
-            self.test_access.read(test_id, ['field1'])
-            self.test_access.read(test_id, ['field2'])
-            self.test_access.read(test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            test_access.field2
-            transaction.cursor.cache.clear()
-
-            # Two access rules on both fields one allowed and one disallowed
-            self.field_access.write(field_access2, {
-                'perm_read': False,
-                })
-            self.test_access.read(test_id, ['field1'])
-            self.failUnlessRaises(Exception, self.test_access.read, test_id,
-                    ['field2'])
-            self.failUnlessRaises(Exception, self.test_access.read, test_id)
-            test_access = self.test_access.browse(test_id)
-            test_access.field1
-            self.failUnlessRaises(Exception, getattr, test_access, 'field2')
-            transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
             # Two access rules on both fields disallowed
-            self.field_access.write(field_access1, {
-                'perm_read': False,
-                })
-            self.failUnlessRaises(Exception, self.test_access.read, test_id,
-                    ['field1'])
-            self.failUnlessRaises(Exception, self.test_access.read, test_id,
-                    ['field2'])
-            self.failUnlessRaises(Exception, self.test_access.read, test_id)
-            test_access = self.test_access.browse(test_id)
-            self.failUnlessRaises(Exception, getattr, test_access, 'field1')
-            self.failUnlessRaises(Exception, getattr, test_access, 'field2')
+            self.field_access.write([field_access1], {
+                    'perm_read': False,
+                    })
+            self.assertRaises(Exception, self.test_access.read, [test.id],
+                ['field1'])
+            self.assertRaises(Exception, self.test_access.read, [test.id],
+                ['field2'])
+            self.assertRaises(Exception, self.test_access.read, [test.id])
+            self.assertRaises(Exception, getattr, test, 'field1')
+            self.assertRaises(Exception, getattr, test, 'field2')
             transaction.cursor.cache.clear()
+            test = self.test_access(test.id)
 
             transaction.cursor.rollback()
 
